X-Git-Url: http://git.vanrenterghem.biz/git.ikiwiki.info.git/blobdiff_plain/ba707cdcd997c09f1fe0efc2addd03f8553303ea..af48316b1d3a54cde1524d47773346f4cd39cb37:/IkiWiki/Plugin/attachment.pm?ds=sidebyside

diff --git a/IkiWiki/Plugin/attachment.pm b/IkiWiki/Plugin/attachment.pm
index a5c42d638..01d0d2478 100644
--- a/IkiWiki/Plugin/attachment.pm
+++ b/IkiWiki/Plugin/attachment.pm
@@ -20,7 +20,9 @@ sub formbuilder_setup (@) { #{{{
 	my $form=$params{form};
 	my $q=$params{cgi};
 
-	if ($form->field("do") eq "edit") {
+	if (defined $form->field("do") && $form->field("do") eq "edit") {
+		# Add attachment field, set type to multipart.
+		$form->enctype(&CGI::MULTIPART);
 		$form->field(name => 'attachment', type => 'file');
 		# These buttons are not put in the usual place, so
 		# are not added to the normal formbuilder button list.
@@ -34,7 +36,8 @@ sub formbuilder_setup (@) { #{{{
 		# Start with the attachments interface toggled invisible,
 		# but if it was used, keep it open.
 		if ($form->submitted ne "Upload Attachment" &&
-		    ! length $q->param("attachment_select")) {
+		    (! defined $q->param("attachment_select") ||
+		    ! length $q->param("attachment_select"))) {
 			$form->tmpl_param("attachments-class" => "toggleable");
 		}
 		else {
@@ -47,7 +50,13 @@ sub formbuilder_setup (@) { #{{{
 
 		$form->field(name => "allowed_attachments", size => 50,
 			fieldset => "admin",
-			comment => "(".htmllink("", "", "ikiwiki/PageSpec", noimageinline => 1).")");
+			comment => "(".
+				htmllink("", "", 
+					"ikiwiki/PageSpec/attachment", 
+					noimageinline => 1,
+					linktext => "Enhanced PageSpec",
+				).")"
+		);
 		if (! IkiWiki::is_admin($user_name)) {
 			$form->field(name => "allowed_attachments", type => "hidden");
 		}
@@ -70,7 +79,7 @@ sub formbuilder (@) { #{{{
 	my $form=$params{form};
 	my $q=$params{cgi};
 
-	return if $form->field("do") ne "edit";
+	return if ! defined $form->field("do") || $form->field("do") ne "edit";
 
 	my $filename=$q->param('attachment');
 	if (defined $filename && length $filename &&
@@ -80,7 +89,19 @@ sub formbuilder (@) { #{{{
 		# This is an (apparently undocumented) way to get the name
 		# of the temp file that CGI writes the upload to.
 		my $tempfile=$q->tmpFileName($filename);
-		
+		if (! defined $tempfile || ! length $tempfile) {
+			# perl 5.8 needs an alternative, awful method
+			if ($q =~ /HASH/ && exists $q->{'.tmpfiles'}) {
+				foreach my $key (keys(%{$q->{'.tmpfiles'}})) {
+					$tempfile=$q->tmpFileName(\$key);
+					last if defined $tempfile && length $tempfile;
+				}
+			}
+			if (! defined $tempfile || ! length $tempfile) {
+				error("CGI::tmpFileName failed to return the uploaded file name");
+			}
+		}
+
 		$filename=IkiWiki::titlepage(
 			IkiWiki::possibly_foolish_untaint(
 				attachment_location($form->field('page')).
@@ -126,7 +147,14 @@ sub formbuilder (@) { #{{{
 		else {
 			my $fh=$q->upload('attachment');
 			if (! defined $fh || ! ref $fh) {
-				error("failed to get filehandle");
+				# needed by old CGI versions
+				$fh=$q->param('attachment');
+				if (! defined $fh || ! ref $fh) {
+					# even that doesn't always work,
+					# fall back to opening the tempfile
+					$fh=undef;
+					open($fh, "<", $tempfile) || error("failed to open \"$tempfile\": $!");
+				}
 			}
 			binmode($fh);
 			writefile($filename, $config{srcdir}, undef, 1, sub {
@@ -298,6 +326,76 @@ sub match_minsize ($$;@) { #{{{
 	}
 } #}}}
 
+sub match_mimetype ($$;@) { #{{{
+	shift;
+	my $wanted=shift;
+
+	my %params=@_;
+	if (! exists $params{file}) {
+		return IkiWiki::FailReason->new("no file specified");
+	}
+
+	# Use ::magic to get the mime type, the idea is to only trust
+	# data obtained by examining the actual file contents.
+	eval q{use File::MimeInfo::Magic};
+	if ($@) {
+		return IkiWiki::FailReason->new("failed to load File::MimeInfo::Magic ($@); cannot check MIME type");
+	}
+	my $mimetype=File::MimeInfo::Magic::magic($params{file});
+	if (! defined $mimetype) {
+		$mimetype="unknown";
+	}
+
+	my $regexp=IkiWiki::glob2re($wanted);
+	if ($mimetype!~/^$regexp$/i) {
+		return IkiWiki::FailReason->new("file MIME type is $mimetype, not $wanted");
+	}
+	else {
+		return IkiWiki::SuccessReason->new("file MIME type is $mimetype");
+	}
+} #}}}
+
+sub match_virusfree ($$;@) { #{{{
+	shift;
+	my $wanted=shift;
+
+	my %params=@_;
+	if (! exists $params{file}) {
+		return IkiWiki::FailReason->new("no file specified");
+	}
+
+	if (! exists $IkiWiki::config{virus_checker} ||
+	    ! length $IkiWiki::config{virus_checker}) {
+		return IkiWiki::FailReason->new("no virus_checker configured");
+	}
+
+	# The file needs to be fed into the virus checker on stdin,
+	# because the file is not world-readable, and if clamdscan is
+	# used, clamd would fail to read it.
+	eval q{use IPC::Open2};
+	error($@) if $@;
+	open (IN, "<", $params{file}) || return IkiWiki::FailReason->new("failed to read file");
+	binmode(IN);
+	my $sigpipe=0;
+	$SIG{PIPE} = sub { $sigpipe=1 };
+	my $pid=open2(\*CHECKER_OUT, "<&IN", $IkiWiki::config{virus_checker}); 
+	my $reason=<CHECKER_OUT>;
+	chomp $reason;
+	1 while (<CHECKER_OUT>);
+	close(CHECKER_OUT);
+	waitpid $pid, 0;
+	$SIG{PIPE}="DEFAULT";
+	if ($sigpipe || $?) {
+		if (! length $reason) {
+			$reason="virus checker $IkiWiki::config{virus_checker}; failed with no output";
+		}
+		return IkiWiki::FailReason->new("file seems to contain a virus ($reason)");
+	}
+	else {
+		return IkiWiki::SuccessReason->new("file seems virusfree ($reason)");
+	}
+} #}}}
+
 sub match_ispage ($$;@) { #{{{
 	my $filename=shift;